Merge pull request #9 from Izakey/FINCN-123
Migrate payroll service from MariaDB to PostgreSQL
diff --git a/.dockerignore b/.dockerignore
new file mode 100644
index 0000000..a3b6dc5
--- /dev/null
+++ b/.dockerignore
@@ -0,0 +1,7 @@
+LICENSE
+README.md
+docs/
+HEADER
+NOTICE.txt
+.git/
+.gitignore
diff --git a/.gitignore b/.gitignore
index 1d62734..91f20f6 100644
--- a/.gitignore
+++ b/.gitignore
@@ -15,3 +15,5 @@
*.log
*.toDelete
+
+*.jar
diff --git a/.travis.yml b/.travis.yml
new file mode 100644
index 0000000..80647d1
--- /dev/null
+++ b/.travis.yml
@@ -0,0 +1,33 @@
+#
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+#
+language: java
+sudo: false
+jdk:
+- openjdk8
+install: true
+script: "./travis.sh"
+env:
+ global:
+ - BUILD_SNAPSHOTS_BRANCH=develop
+ - ARTIFACTORY_URL=https://mifos.jfrog.io/mifos
+ - ARTIFACTORY_USER=travis-ci
+ - secure: "CEwvv6FRZQvFB2PO7HE0rvjQB2nvGvbE7uLzSeBJDTLc3KygcokOlaDBBolpvHUvydLG7RTQwLKLZv4C5E0aSgIFyszcDlPFOn9638GaLqmdhT41ihUKlmMkv6xAbQhq2cCEoIy8HWrcnOg6e5pj4FXlfKDRI/GNDMV+x0GblW0UoYSSyMb45SWGc0PJxa5vPYaukGnNQoVfqcynE5rHqvpbaBBbXgidQsLsZRp/vukcsblIpo04N5X+mjoQVGNCsgng/Vt5p/B/VFKC8l6kxKIq1eIDe+wjdotfBw9krXjKWZVq/whDvGvCHBdwCM5rGrLUBN0fJ2qf01loo05t57s0YcBxtAZtlxhHppW7TW2hv7lH+HoN+pNEFj7fnSFtldCvwqJwlqWBOFAQhLVNPajZQRwrcU6RDnPPeUEvOCvUveSfSecvlsJ3ykbA6OG1Xalc7y+VRQdthxuNzI0TA6hrd8/lzuWv2TKlBErPdtapPxGN42UxG/YjnS/57bv6koQ0t7h/Pf73v+Xb4kqZNP1fN8E2vOb/0CulQl7GLgIHKSCBU2yJ5MbePwTLsgeU4WPRqPrItNZcxnzTWZ3DGneFk81CVqpx0hXetWt7HpOEnZu84/mMGOZGkcH0d8cCcfCPKCJayO27bwqddj8cZuM953dB6ioma2nPVtLUB3k="
+after_failure:
+ - ./gradlew rat
+ - cat api/build/reports/rat/rat-report.txt
diff --git a/Dockerfile b/Dockerfile
new file mode 100644
index 0000000..2fd3104
--- /dev/null
+++ b/Dockerfile
@@ -0,0 +1,36 @@
+#
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+#
+FROM openjdk:8-jdk-alpine AS builder
+RUN mkdir builddir
+COPY . builddir
+WORKDIR builddir
+RUN ./gradlew publishToMavenLocal
+
+FROM openjdk:8-jdk-alpine AS runner
+
+ARG payroll_port=2030
+
+ENV server.max-http-header-size=16384 \
+ cassandra.clusterName="Test Cluster" \
+ server.port=$payroll_port
+
+WORKDIR /tmp
+COPY --from=builder /builddir/service/build/libs/service-0.1.0-BUILD-SNAPSHOT-boot.jar ./payroll-service-boot.jar
+
+CMD ["java", "-jar", "payroll-service-boot.jar"]
diff --git a/README.md b/README.md
index 8d684de..eed37e6 100644
--- a/README.md
+++ b/README.md
@@ -1,4 +1,4 @@
-# Apache Fineract CN Payroll
+# Apache Fineract CN Payroll [![Build Status](https://api.travis-ci.com/apache/fineract-cn-payroll.svg?branch=develop)](https://travis-ci.com/apache/fineract-cn-payroll)
This project provides functionality to configure payroll allocations and distribute payroll payments for customers.
diff --git a/api/build.gradle b/api/build.gradle
index 5b9924a..a11f487 100644
--- a/api/build.gradle
+++ b/api/build.gradle
@@ -28,6 +28,7 @@
plugins {
id "com.github.hierynomus.license" version "0.13.1"
id("org.nosphere.apache.rat") version "0.3.1"
+ id "com.jfrog.artifactory" version "4.9.5"
}
apply from: '../shared.gradle'
@@ -51,7 +52,7 @@
from components.java
groupId project.group
artifactId project.name
- version project.version
+ version project.findProperty('externalVersion') ?: project.version
}
}
}
diff --git a/build.gradle b/build.gradle
index 848847a..eeb68fb 100644
--- a/build.gradle
+++ b/build.gradle
@@ -39,6 +39,14 @@
dependsOn publishComponentTestToMavenLocal
}
+task artifactoryPublish {
+ group 'all'
+ dependsOn publishToMavenLocal
+ dependsOn gradle.includedBuild('api').task(':artifactoryPublish')
+ dependsOn gradle.includedBuild('service').task(':artifactoryPublish')
+ dependsOn gradle.includedBuild('component-test').task(':artifactoryPublish')
+}
+
task prepareForTest {
group 'all'
dependsOn publishToMavenLocal
diff --git a/component-test/build.gradle b/component-test/build.gradle
index 7723165..ec66397 100644
--- a/component-test/build.gradle
+++ b/component-test/build.gradle
@@ -33,6 +33,7 @@
plugins {
id "com.github.hierynomus.license" version "0.13.1"
id("org.nosphere.apache.rat") version "0.3.1"
+ id "com.jfrog.artifactory" version "4.9.5"
}
apply from: '../shared.gradle'
apply plugin: 'org.asciidoctor.convert'
@@ -60,8 +61,9 @@
publishing {
publications {
- mavenJava(MavenPublication) {
+ componentTest(MavenPublication) {
from components.java
+ version project.findProperty('externalVersion') ?: project.version
}
}
}
diff --git a/service/build.gradle b/service/build.gradle
index abbd0cd..b314f83 100644
--- a/service/build.gradle
+++ b/service/build.gradle
@@ -32,6 +32,7 @@
plugins {
id "com.github.hierynomus.license" version "0.13.1"
id("org.nosphere.apache.rat") version "0.3.1"
+ id "com.jfrog.artifactory" version "4.9.5"
}
apply from: '../shared.gradle'
@@ -70,14 +71,14 @@
from components.java
groupId project.group
artifactId project.name
- version project.version
+ version project.findProperty('externalVersion') ?: project.version
}
bootService(MavenPublication) {
// "boot" jar
artifact ("$buildDir/libs/$project.name-$version-boot.jar")
groupId project.group
artifactId ("$project.name-boot")
- version project.version
+ version project.findProperty('externalVersion') ?: project.version
}
}
}
diff --git a/shared.gradle b/shared.gradle
index ee5384a..eb3fd8a 100644
--- a/shared.gradle
+++ b/shared.gradle
@@ -45,6 +45,7 @@
repositories {
jcenter()
mavenLocal()
+ maven { url 'https://mifos.jfrog.io/mifos/libs-snapshot/' }
}
dependencyManagement {
@@ -76,6 +77,22 @@
duplicatesStrategy = DuplicatesStrategy.EXCLUDE
}
+artifactory {
+ contextUrl = System.getenv("ARTIFACTORY_URL")
+ publish {
+ repository {
+ repoKey = project.findProperty('artifactoryRepoKey')
+ username = System.getenv("ARTIFACTORY_USER")
+ password = System.getenv("ARTIFACTORY_PASSWORD")
+ }
+
+ defaults {
+ publications ('api', 'componentTest', 'service', 'bootService')
+ }
+ }
+}
+artifactoryPublish.dependsOn('clean','publishToMavenLocal')
+
license {
header rootProject.file('../HEADER')
strictCheck true
@@ -96,6 +113,8 @@
"**/build/**",
"gradlew",
"gradlew.bat",
- "README.md"
+ "README.md",
+ "**/.dockerignore/**"
]
+ plainOutput = true
}
\ No newline at end of file
diff --git a/travis.sh b/travis.sh
new file mode 100755
index 0000000..03a75ee
--- /dev/null
+++ b/travis.sh
@@ -0,0 +1,71 @@
+#!/usr/bin/env bash
+#
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+#
+
+# Documentation: https://cwiki.apache.org/confluence/display/FINERACT/Fineract-CN+Artifactory
+
+#Exit immediately if a command exits with a non-zero status.
+set -e
+EXIT_STATUS=0
+
+# Builds and Publishes a SNAPSHOT
+function build_snapshot() {
+ echo -e "Building and publishing a snapshot out of branch [$TRAVIS_BRANCH]"
+ ./gradlew -PartifactoryRepoKey=libs-snapshot-local -DbuildInfo.build.number=${TRAVIS_COMMIT::7} artifactoryPublish --stacktrace || EXIT_STATUS=$?
+}
+
+# Builds a Pull Request
+function build_pullrequest() {
+ echo -e "Building pull request #$TRAVIS_PULL_REQUEST of branch [$TRAVIS_BRANCH]. Won't publish anything to Artifactory."
+ ./gradlew publishToMavenLocal rat || EXIT_STATUS=$?
+}
+
+# For other branches we need to add branch name as prefix
+function build_otherbranch() {
+ echo -e "Building a snapshot out of branch [$TRAVIS_BRANCH] and publishing it with prefix '${TRAVIS_BRANCH}-SNAPSHOT'"
+ ./gradlew -PartifactoryRepoKey=libs-snapshot-local -DbuildInfo.build.number=${TRAVIS_COMMIT::7} -PexternalVersion=${TRAVIS_BRANCH}-SNAPSHOT artifactoryPublish --stacktrace || EXIT_STATUS=$?
+}
+
+# Builds and Publishes a Tag
+function build_tag() {
+ echo -e "Building tag [$TRAVIS_TAG] and publishing it as a release"
+ ./gradlew -PartifactoryRepoKey=libs-release-local -PexternalVersion=$TRAVIS_TAG artifactoryPublish --stacktrace || EXIT_STATUS=$?
+
+}
+
+echo -e "TRAVIS_BRANCH=$TRAVIS_BRANCH"
+echo -e "TRAVIS_TAG=$TRAVIS_TAG"
+echo -e "TRAVIS_COMMIT=${TRAVIS_COMMIT::7}"
+echo -e "TRAVIS_PULL_REQUEST=$TRAVIS_PULL_REQUEST"
+
+# Build Logic
+if [ "$TRAVIS_PULL_REQUEST" != "false" ]; then
+ build_pullrequest
+elif [ "$TRAVIS_PULL_REQUEST" == "false" ] && [ "$TRAVIS_BRANCH" != "$BUILD_SNAPSHOTS_BRANCH" ] && [ "$TRAVIS_TAG" == "" ] ; then
+ build_otherbranch
+elif [ "$TRAVIS_PULL_REQUEST" == "false" ] && [ "$TRAVIS_BRANCH" == "$BUILD_SNAPSHOTS_BRANCH" ] && [ "$TRAVIS_TAG" == "" ] ; then
+ build_snapshot
+elif [ "$TRAVIS_PULL_REQUEST" == "false" ] && [ "$TRAVIS_TAG" != "" ]; then
+ build_tag
+else
+ echo -e "WARN: Unexpected env variable values => Branch [$TRAVIS_BRANCH], Tag [$TRAVIS_TAG], Pull Request [#$TRAVIS_PULL_REQUEST]"
+ ./gradlew clean build
+fi
+
+exit ${EXIT_STATUS}